
import 'package:routex_core/src/controller.dart';
import 'package:routex_core/src/router.dart';

class RouterBindable {
  final String path;
  final List<Controller> controllers;
  final void Function(Router) before;
  final void Function(Router) after;
  final Router Function() routerFactory;

  RouterBindable({this.routerFactory , this.path, this.controllers, this.before, this.after});

  void bindRouter(Router router) {
    if (before != null) {
      before(router);
    }
    if (controllers != null) {
      if (path != null) {
        final subRouter = routerFactory();
        controllers.forEach((c) => c.bindRouter(subRouter));
        router.mountSubRouter(
          path,
          subRouter,
        );
      } else {
        controllers.forEach((c) => c.bindRouter(router));
      }
    }
    if (after != null) {
      after(router);
    }
  }
}
