import '../util/objects.dart';

class ResponseStatusException implements Exception {
  final int statusCode;
  final Object failure;
  final String reason;

  ResponseStatusException(this.statusCode, {this.reason,this.failure});

  @override
  String toString() {
    String message = """"
    ResponseStatusException: $statusCode;
    Reason: $reason;
    
    """;
    if (failure != null) {
      if (Objects.cast<Error>(failure, (error) => print(error.stackTrace)) !=
          null) {
        message += failure.toString();
      } else if (Objects.cast<Exception>(failure) != null) {
        message += failure.toString();
      } else {
        message += failure.toString();
      }
    }
    return message;
  }
}
