import 'dart:io';


import 'package:routex_core/src/http_method.dart';

import 'http_server_response.dart';

/// Represents routing request.
abstract class HttpServerRequest {
  String path();

  HttpServerResponse response();

  Map<String, dynamic> params();

  HttpMethod method();

  void setPath(String path);

  List<Cookie> cookies();

  /// All HTTP headers sent with this request.
  HttpHeaders headers();

  Map<String, dynamic> getBodyAsJson();
}
